<template>
  <q-form ref="form" class="q-pl-sm" @submit="onSubmit" @reset="onReset">
    <div class="row q-col-gutter-sm">
      <div class="col">
        <q-input
          outlined
          bottom-slots
          dense
          standout
          label="email *"
          type="email"
          :readonly="editing"
          :rules="[val => !!val || 'Campo es requerido.']"
          v-model="draft.username"
        >
          <template v-slot:prepend>
            <q-icon name="mail" />
          </template>
        </q-input>
      </div>
      <div class="col">
        <q-input
          outlined
          bottom-slots
          dense
          label="Nombre de la Empresa *"
          :rules="[val => !!val || 'Campo es requerido.']"
          v-model="draft.name"
        />
      </div>
    </div>
    <div class="row q-col-gutter-sm">
      <div class="col">
        <q-input
          outlined
          bottom-slots
          dense
          label="Rif *"
          unmasked-value
          mask="R-########-#"
          lazy-rules
          :rules="[
            val => !!val || 'Campo es requerido.',
            val => val.length == 10 || 'El Rif debe contener 10 caracteres'
          ]"
          v-model="draft.rif"
        />
      </div>
      <div class="col">
        <q-input
          v-if="showPasswd"
          outlined
          bottom-slots
          dense
          label="Contraseña *"
          :type="isPwd?'password':'text'"
          :rules="[val => !!val || 'Campo es requerido.']"
          v-model.trim="draft.password"
        >
          <template v-slot:append>
            <q-icon
              :name="isPwd?'visibility_off':'visibility'"
              class="cursor-pointer"
              @click="isPwd = !isPwd"
            />
          </template>
        </q-input>
      </div>
    </div>
    <div class="row q-col-gutter-sm">
      <div class="col">
        <q-select
          outlined
          clearable
          dense
          options-dense
          use-input
          emit-value
          map-options
          label="País *"
          :options="countryOptions"
          :loading="loadingCountry"
          :rules="[val => !!val || 'Campo es requerido.']"
          @filter="filterCountry"
          @input="getCities"
          v-model="draft.country"
        >
          <template v-slot:no-option>
            <q-item>
              <q-item-section class="text-grey">
                No results
              </q-item-section>
            </q-item>
          </template>
        </q-select>
        <q-input
          outlined
          bottom-slots
          dense
          standout
          label="Número Telefónico *"
          type="tel"
          unmasked-value
          mask="(####) ### - ####"
          :prefix="draft.country && draft.country.code || ''"
          :rules="[
            val => !!val || 'Campo es requerido.',
            val => val.length == 11 || 'El número telefónico debe contener 11 caracteres'
          ]"
          v-model="draft.phone"
        >
          <template v-slot:prepend>
            <q-icon name="phone" />
          </template>
        </q-input>
      </div>
      <div class="col">
        <q-select
          outlined
          clearable
          dense
          options-dense
          use-input
          emit-value
          map-options
          label="Ciudad *"
          :options="cityOptions"
          :disable="disabledCity"
          :loading="loadingCountry"
          :rules="[val => !!val || 'Campo es requerido.']"
          @filter="filterCity"
          @input="getCity"
          v-model="draft.city"
        >
          <template v-slot:no-option>
            <q-item>
              <q-item-section class="text-grey">
                No results
              </q-item-section>
            </q-item>
          </template>
        </q-select>
        <q-input
          outlined
          bottom-slots
          dense
          type="textarea"
          label="Dirección *"
          rows="2"
          :rules="[val => !!val || 'Campo es requerido.']"
          :input-style="{ resize: 'none' }"
          v-model="draft.address"
        />
      </div>
    </div>
    <div class="row q-col-gutter-sm">
      <div class="col q-pb-md">
        <gmap-map
          v-if="draft.country"
          ref="mapRef"
          style="width: 100%; height: 400px"
          :center="mapOptions.center"
          :zoom="mapOptions.zoom"
          :options="{
            zoomControl: true,
            mapTypeControl: false,
            scaleControl: false,
            streetViewControl: false,
            fullscreenControl: false
          }"
          @click="onClick"
        >
          <gmap-marker
            :icon="{
              url: 'statics/icons/ic_point_map.png',
            }"
            :position="mapOptions.center"
            :clickable="true"
            :draggable="true"
          />
        </gmap-map>
      </div>
    </div>
    <div class="q-pb-lg">
      <q-btn flat label="Limpiar" type="reset" color="primary" class="q-ml-sm"/>
      <q-btn :label="submit" type="submit" color="primary" :loading="isLoading">
        <template v-slot:loading>
          <q-spinner-gears color="white" />
        </template>
      </q-btn>
    </div>
  </q-form>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
  props: ['business', 'editing', 'isLoading'],
  data () {
    return {
      show: true,
      draft: JSON.parse(JSON.stringify(this.business)),
      isPwd: true,
      loadingCountry: false,
      loadingCity: false,
      mapOptions: {
        center: {},
        zoom: 5
      }
    }
  },
  mounted () {
    this.getCountries()
  },
  watch: {
    'business': function (data) {
      this.draft = JSON.parse(JSON.stringify(data))
      if (this.draft.country) {
        this.getCities(this.draft.country)
      }
    }
  },
  computed: {
    ...mapGetters({
      countryOptions: 'shared/countryOptions',
      cityOptions: 'shared/cityOptions'
    }),
    submit () {
      return this.editing ? 'Actualizar' : 'Guardar'
    },
    disabledCity () {
      if (this.draft.country) {
        return this.draft.country.length === 0
      }
      return true
    },
    showPasswd () {
      return !this.editing && this.$route.name === 'auth.register.business'
    }
  },
  methods: {
    async getCountries () {
      this.loadingCountry = true
      await this.$store.dispatch('shared/getCountries')
      this.loadingCountry = false
    },
    async getCities (country) {
      if (country) {
        this.loadingCity = true
        if (this.draft.geoLocation.coordinates) {
          this.mapOptions.center = {
            lat: this.draft.geoLocation.coordinates[0],
            lng: this.draft.geoLocation.coordinates[1]
          }
          this.mapOptions.zoom = 18
        } else if (this.draft.city) {
          this.mapOptions.center = {
            lat: this.draft.city.geoLocation.coordinates[0],
            lng: this.draft.city.geoLocation.coordinates[1]
          }
          this.mapOptions.zoom = 10
        } else {
          this.mapOptions.center = {
            lat: country.geoLocation.coordinates[0],
            lng: country.geoLocation.coordinates[1]
          }
          this.mapOptions.zoom = 5
        }
        await this.$store.dispatch('shared/getCities', country._id)
        this.loadingCity = false
      }
    },
    filterCountry (search, update) {
      update(() => {
        this.$store.commit('shared/SEARCHCOUNTRIES', search)
      })
    },
    filterCity (search, update) {
      update(() => {
        this.$store.commit('shared/SEARCHCITIES', search)
      })
    },
    getCity (city) {
      if (city) {
        this.mapOptions.center = {
          lat: city.geoLocation.coordinates[0],
          lng: city.geoLocation.coordinates[1]
        }
        this.mapOptions.zoom = 10
      }
    },
    onClick (e) {
      this.mapOptions.center = {
        lat: e.latLng.lat(),
        lng: e.latLng.lng()
      }
      this.draft.geoLocation.coordinates = [this.mapOptions.center.lat, this.mapOptions.center.lng]
    },
    async onSubmit () {
      const process = await this.$refs.form.validate()
      if (process) {
        this.$emit('save', this.draft)
      }
    },
    onReset () {
      this.draft = JSON.parse(JSON.stringify(this.business))
    }
  }
}
</script>
